/*
	ASPI module
	Copyright 1995,1996 (C) ITO Takayuki
*/

#ifndef _ASPISCSI_H
#define	_ASPISCSI_H

#include	"typedef.h"

#define	CDB_SIZE_MAX	12
#define	SENSE_ALLOC_MAX	15

#undef	SCSI_1
#define	SCSI_2

#define	SCSI_DIRECT_ACCESS	0
#define	SCSI_CDROM	5
#define	SCSI_MO	7

enum
{
	ASPI_ADAPTER_INQUIRY,
	ASPI_GET_DEVICE_TYPE,
	ASPI_EXEC_SCSI_IO,
	ASPI_ABORT_SCSI_IO,
	ASPI_RESET_SCSI_DEVICE,
	ASPI_SET_ADAPTER_PARAMS,
	ASPI_GET_DRIVE_INFO
};

extern BYTE	ASPICommandStatus;
enum
{
	ASPICS_PROGRESS,
	ASPICS_COMPLETE,
	ASPICS_ABORT,
	ASPICS_ERROR = 4,
	ASPICS_INVALID_REQUEST = 0x80,
	ASPICS_INVALID_ADAPTER = 0x81,
	ASPICS_NOT_INSTALLED = 0x82
};

#define	SRB_HEADER	\
	BYTE			CommandCode;\
	volatile BYTE	Status;\
	BYTE			AdapterNo;\
	BYTE			SCSIRequestFlags;\
	BYTE			Reserved [4];

#pragma pack(1)		/* for LSI-C */

struct InquirySRB
{
	SRB_HEADER
	
	BYTE	Adapters;
	BYTE	AdapterSCSIID;
	char	ASPIManagerID [16];
	char	HostAdapterID [16];
	BYTE	AdapterParams [16];
};

struct DeviceTypeSRB
{
	SRB_HEADER
	
	BYTE	TargetSCSIID;
	BYTE	TargetLUN;
	BYTE	DeviceType;
};

struct ExecIOSRB
{
	SRB_HEADER
	
	BYTE	TargetSCSIID;
	BYTE	TargetLUN;
	DWORD	DataAllocLength;
	BYTE	SenseAllocLength;
	BYTE	far *DataBufPtr;
	struct ExecIOSRB	far *SRBLinkPtr;
	BYTE	CDBLength;
	BYTE	AdapterStatus;
	BYTE	TargetStatus;
	void	(far *PostRoutine)(void);
	BYTE	Reserved2 [34];
	BYTE	cdb [CDB_SIZE_MAX+SENSE_ALLOC_MAX];
};

#pragma pack()

#define	RF_POST			0x01
#define	RF_LINK			0x02
#define	RF_DIR_AUTO		0x00
#define	RF_DIR_TOHOST	0x08
#define	RF_DIR_TOTARGET	0x10
#define	RF_DIR_NOXFER	0x18

extern BYTE	ASPIAdapterStatus;
enum
{
	ASPIAS_NOERROR,
	ASPIAS_TIMEOUT = 0x11,
	ASPIAS_OVERRUN,
	ASPIAS_BUSFREE,
	ASPIAS_BUSPHASE
};

extern BYTE	SCSIStatus;
#define	ASPITargetStatus	SCSIStatus
enum
{
	S_GOOD,
	S_CHECK = 0x02,
	S_BUSY  = 0x08,
	S_CONFL = 0x18
};

extern BYTE	SCSISenseKey;
extern BYTE	SCSISenseCode;
extern BYTE	SCSISenseCodeQ;

extern BOOL	UnitAtnRetry;
extern int	Adapters;
extern WORD	blocksize;

#ifdef __cplusplus
extern "C" {
#endif

int		InitASPI	(void);
char	far *ASPIAdapterInquiry	(int AdapterNo);
int		ASPIGetDeviceType		(int AdapterNo, int scsiid, int lun);

int		FormatUnit		(int AdapterNo, int scsiid, int lun);
int		FormatUnit2		(int AdapterNo, int scsiid, int lun, int flags, 
						int interleave, BYTE far *buf, int buflen);
int		Inquiry			(int AdapterNo, int scsiid, int lun, BYTE far *buf, int buflen);
int		TestUnitReady	(int AdapterNo, int scsiid, int lun);
int		ReadCapacity	(int AdapterNo, int scsiid, int lun, DWORD far *buf);
int		StartStopUnit	(int AdapterNo, int scsiid, int lun, int flag);
int		PreventAllowMediumRemoval	(int AdapterNo, int scsiid, int lun, 
									int flag);
int		Read10			(int AdapterNo, int scsiid, int lun, DWORD lba, 
						WORD count, BYTE far *buf);
int		Write10			(int AdapterNo, int scsiid, int lun, DWORD lba, 
						WORD count, BYTE far *buf);
int		WriteAndVerify	(int AdapterNo, int scsiid, int lun, DWORD lba, 
						WORD count, BYTE far *buf);
int		WriteSame		(int AdapterNo, int scsiid, int lun, DWORD lba, 
						WORD count, BYTE far *buf);

int		ModeSense	(int AdapterNo, int scsiid, int lun, 
					BYTE far *buf, int buflen);
int		RequestSense	(int AdapterNo, int scsiid, int lun, 
						BYTE far *buf, int buflen);

#ifdef __cplusplus
}
#endif

#endif

