/*
	generate locale file from locale definition file
	Copyright 1995,1996 (C) ITO Takayuki
	for MS-DOS
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	"locale.h"
#include	"typedef.h"
#include	"msgcat.h"

void	main	(int argc, char **argv)

{
	char	buf [80], *p1, *p2, *p3, *p4;
	FILE	*fi, *fo;
	int		l, c;
	enum { DEFINE, ALIAS } mode;
	struct localedir_t	localedirent;
	struct aliasdir_t	aliasdirent;
	
	if (argc != 3)
	{
		fputs ("usage: genloc locale-file locale-definition-file\n", stderr);
		exit (EXIT_FAILURE);
	}
	
	if ((fi = fopen (argv [2], "rt")) == NULL)
	{
		fputs ("can't open locale def file.\n", stderr);
		exit (EXIT_FAILURE);
	}
	if ((fo = fopen (argv [1], "wb")) == NULL)
	{
		fputs ("can't create locale file.\n", stderr);
		exit (EXIT_FAILURE);
	}
	
	fgets (buf, sizeof buf, fi);
	if (strncmp (buf, "locale", 6) == 0)
		mode = DEFINE;
	else if (strncmp (buf, "alias", 5) == 0)
		mode = ALIAS;
	while (fgets (buf, sizeof buf, fi) != NULL)
	{
		l = strlen (buf);
		if (buf [l-1] == '\n')
			buf [--l] = '\0';
		c = buf [0];
		if (c != '#' && c != '\0')
		{
			p1 = strtok (buf, " \t");
			p2 = strtok (NULL, " \t");
			if (mode == DEFINE)
			{
				p3 = strtok (NULL, " \t");
				p4 = strtok (NULL, " \t");
				memset (&localedirent, 0, sizeof localedirent);
				localedirent.country = atoi (p1);
				localedirent.codepage = atoi (p2);
				localedirent.kbdcode =  (*p3 == '*' ? 0 : *(WORD *)p3);
				sprintf (localedirent.locname, "%.15s", p4);
				fwrite (&localedirent, sizeof localedirent, 1, fo);
			}
			else
			{
				memset (&aliasdirent, 0, sizeof aliasdirent);
				sprintf (aliasdirent.alias,   "%.15s", p1);
				sprintf (aliasdirent.locname, "%.15s",  p2);
				fwrite (&aliasdirent, sizeof aliasdirent, 1, fo);
			}
		}
	}
	
	fclose (fi);
	fclose (fo);
	exit (EXIT_SUCCESS);
}
