/*
	public domain getopt(3)
*/

#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h>
#include	"typedef.h"
#include	"getopt.h"
#include	"m_getopt.h"

#ifndef NLS
#define	catgets(i,sn,mn,s)	(s)
#else
#include	"msgcat.h"
#define	NL_SETN	1
#define	OFLAG	NL_CAT_LOCALE
static nl_catd	catd;
static BOOL	initf = FALSE;
#endif

int	opterr = 1;
int	optind = 1;
int	optopt;
char	*optarg;

static	void	errdisp(char *as)

{
	if(opterr){
		fprintf (stderr, as, optopt);
	}
}

int	getopt(int ac, char **av, char *opts)

{
	static	char	*curopt = NULL;
	register char	*cp;
	
#ifdef NLS
	if (!initf)
	{
		catd = catopen ("getopt", OFLAG);
		initf = TRUE;
	}
#endif
	
	if(curopt == NULL || !*curopt){
		if(optind >= ac || *(curopt = av[optind]) != '-' || !curopt[1])
			return EOF;
		if(!strcmp("-", ++curopt))
			return (optind++, EOF);
	}
	if(':' == (optopt = *curopt++) || NULL == (cp = strchr(opts, optopt))){
		errdisp(catgets (catd, NL_SETN, 1, MSG_1));
		if(!*curopt) optind++;
		return '?';
	}
	if(*++cp == ':'){
		optind++;
		if(*curopt){
			optarg = curopt;
			curopt = NULL;
		} else {
			if(optind >= ac){
				errdisp(catgets (catd, NL_SETN, 2, MSG_2));
				return '?';
			} else {
				optarg = av[optind++];
			}
			 /* now *curopt == '\0' */
		}
	} else {
		optarg = NULL;
		if(!*curopt) optind++;
	}
	return optopt;
}

#ifdef DEBUG
main(ac, av)
int	ac;
char	**av;
{
	int	c;

	opterr = 1;
	while(EOF != (c = getopt(ac, av, "ab:cd:"))){
		printf("ret %c, optopt %c, optarg %s, optind %d\n", c,
			optopt, optarg == NULL ? "(NULL)" : optarg, optind);
	}
	for(ac -= optind, av += optind; ac; ac--, av++)
		printf("arg: '%s'\n", *av);
}
#endif

