/*
	XPG compatible locale
	for MS-DOS
	Copyright 1996 (C) ITO Takayuki
*/

#ifndef _LOCALE_H
#define _LOCALE_H

#include	<stddef.h>
#include	"typedef.h"

#define	LOCALEFILE	"locale.dir"
#define	ALIASFILE	"locale.ali"

#define	C_LOCALE	"C"

#define	NL_LANGMAX	15
#define	LC_BUFSIZ	NL_LANGMAX

#define	IsDBCSLeadByte(c)	(DBCSLeadTable[(BYTE)(c)])

extern BYTE	DBCSLeadTable [];

struct localedir_t
{
	WORD	country;
	WORD	codepage;
	WORD	kbdcode;
	char	reserved [10];
	char	locname [16];
};

struct aliasdir_t
{
	char	alias [16];
	char	locname [16];
};

#ifdef __cplusplus
extern "C" {
#endif

BYTE	far *DOSGetDBCSVector	(void);
void	InitDBCSLeadTable	(void);

#ifdef __cplusplus
}
#endif

#ifdef __TURBOC__
	#include	<locale.h>
	#ifndef LC_MESSAGES
	#define	LC_MESSAGES	(LC_TIME+1)
	#endif

#else
enum {
	LC_ALL,
	LC_COLLATE,
	LC_CTYPE,
	LC_MONETARY,
	LC_NUMERIC,
	LC_TIME,
	LC_MESSAGES
};

struct lconv
{
	char	*decimal_point;
	char	*thousands_sep;
	char	*grouping;
	char	*int_curr_symbol;
	char	*currency_symbol;
	char	*mon_decimal_point;
	char	*mon_thousands_sep;
	char	*mon_grouping;
	char	*positive_sign;
	char	*negative_sign;
	char	int_frac_digits;
	char	frac_digits;
	char	p_cs_precedes;
	char	p_sep_by_space;
	char	n_cs_precedes;
	char	n_sep_by_space;
	char	p_sign_posn;
	char	n_sign_posn;
};

struct COUNTRY
{
	int		co_date;
	char	co_curr  [5];
	char	co_thsep [2];
	char	co_desep [2];
	char	co_dtsep [2];
	char	co_tmsep [2];
	char	co_currstyle;
	char	co_digits;
	char	co_time;
	long	co_case;
	char	co_dasep [2];
	char	co_fill  [10];
};

#ifdef __cplusplus
extern "C" {
#endif

struct COUNTRY	*country (int ctcode, struct COUNTRY *ctinfo);
char	*setlocale	(int category, const char *locale);
struct lconv	*localeconv	(void);

#ifdef __cplusplus
}
#endif

#endif	/* __TURBOC__ */

#define	LC_MIN	LC_COLLATE
#define	LC_MAX	LC_MESSAGES

#endif
