/*
	miscellaneous library for MS-DOS
	Copyright 1996 (C) ITO Takayuki
*/

#include	<dos.h>
#include	<string.h>
#include	"typedef.h"
#include	"misclib.h"

DWORD	ntohl	(DWORD n)

{
	BYTE	*buf;

	buf = (BYTE *) &n;
	return
		((DWORD) buf [0] << 24) + 
		((DWORD) buf [1] << 16) + 
		((DWORD) buf [2] <<  8) + 
		 (DWORD) buf [3];
}

WORD	ntohs	(WORD n)

{
	BYTE	*buf;
	
	buf = (BYTE *) &n;
	return
		((WORD) buf [0] <<  8) + 
		 (WORD) buf [1];
}

BOOL	ispc98	(void)

{
	static BYTE	PC98FarJump [5] = { 0xEA, 0x00, 0x00, 0x80, 0xFD };
	
	return memcmp (MK_FP (0xFFFF, 0), PC98FarJump, sizeof PC98FarJump) == 0;
}

BYTE	far *PC98GetDAUATable	(void)

{
	union REGS		regs;
	struct SREGS	sregs;
	static BYTE		DAUATable [0x60];
	BYTE			far *Table;
	
	regs.x.ax = 0;
	regs.h.cl = 0x12;
	int86 (0xDC, &regs, &regs);
	if (regs.x.ax == 0)
		Table = MK_FP (0x0060, 0x006C);
	else
	{
		Table = DAUATable;
		regs.x.dx = FP_OFF (Table);
		sregs.ds = FP_SEG (Table);
		regs.h.cl = 0x13;
		int86x (0xDC, &regs, &regs, &sregs);
	}
	return Table;
}

int		PC98ConvertDAUAIntoDrive	(BYTE daua)
/* this routine is slightly incomplete */

{
	BYTE	far *p;
	int		drive;
	
	p = PC98GetDAUATable () + 0x1B;
	for (drive = 0; drive < 26; drive++, p += 2)
		if (*p == daua)
			break;
	if (drive >= 26)
		drive = FAILURE;
	return drive;
}

BYTE	far *DOSGetDPBAddress (int drive)

{
	union REGS		regs;
	struct SREGS	sregs;
	
	regs.h.dl = drive;
	regs.h.ah = 0x32;
	intdosx (&regs, &regs, &sregs);
	return MK_FP (sregs.ds, regs.x.bx);
}

void	PC98ForceDPBUpdate	(int scsiid, int drive)

{
	union REGS	regs;
	
	regs.x.ax = 1;
	regs.h.dl = scsiid;
	regs.h.cl = 9;
	int86 (0xDC, &regs, &regs);
	DOSGetDPBAddress (drive + 1);
}

