/*
	moe - removable medium ejecter
	Copyright 1995,1996 (C) ITO Takayuki
	original for HP-UX
	ported for MS-DOS, FreeBSD, SunOS, OSF/1
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#ifdef MSDOS
	#include	"typedef.h"
	#include	"aspiscsi.h"
	#include	"getopt.h"
	#ifdef NLS
		#include	"locale.h"
		#include	"msgcat.h"
		#define	CATFLAG	NL_CAT_LOCALE
		#define	NL_SETN	1
	#else
		#define	catgets(i,sn,mn,s)	(s)
	#endif
	#define	CLOSE(f)
#endif

#ifdef unix
	#include	<fcntl.h>
	#include	<unistd.h>
	#ifdef hpux
		#include	<sys/scsi.h>
	#endif
	#ifdef NLS
		#include	<locale.h>
		#include	<nl_types.h>
		#ifdef hpux
			#include	<msgcat.h>
			#define	CATFLAG	0
		#elif defined osf1
			#define	CATFLAG	NL_CAT_LOCALE
		#else
			#define	CATFLAG	0
		#endif
		#define	NL_SETN	1
	#else
		#define	catgets(i,sn,mn,s)	(s)
	#endif
	#include	"typedef.h"
	#ifdef hpux
		#include	"hpuxscsi.h"
		#define	CLOSE(f)	close(f)
		#define	OPENFLAG	O_RDWR
	#elif defined osf1
		#include	"osf1scsi.h"
		#define	CLOSE(f)	CloseCAM()
	#elif defined sunos4
		#include	"sunscsi.h"
		#include	"getopt.h"
		#define	CLOSE(f)	close(f)
		#define	OPENFLAG	(O_RDONLY|O_NDELAY)
	#elif defined sunos5
		#include	"sunscsi.h"
		#define	CLOSE(f)	close(f)
		#define	OPENFLAG	(O_RDONLY|O_NDELAY)
	#elif defined freebsd
		#include	"fbsdscsi.h"
		#define	CLOSE(f)	close(f)
		#define	OPENFLAG	O_RDWR
	#elif defined linux
		#include	"linuscsi.h"
		#define	CLOSE(f)	close(f)
		#define	OPENFLAG	O_RDWR
	#endif
#endif

#include	"m_moe.h"

#define	NAME		"moe"

static int	mode, devtype;

#ifdef MSDOS
	static int	ha_id = 0, scsi_id = -1, lun = 0;
	#define	FD	ha_id, scsi_id, lun
#else
	#ifdef osf1
		static int	ha_id = 0, scsi_id = -1, lun = 0;
		#define	FD	ha_id, scsi_id, lun
	#else
		static char	devicefile [] = DEVICE_FILE;
		static int	fd;
		#define	FD	fd
	#endif
#endif

#ifdef NLS
static nl_catd	catd;
#endif

void	banner	(void)

{
#ifdef MSDOS
	putchar ('\n');
#endif
	fprintf (stdout, (catgets (catd, NL_SETN, 1, MSG_1)), NAME, RELEASE);
}

void	usage	(void)

{
	fprintf (stderr, (catgets (catd, NL_SETN, 4, MSG_4)), NAME);
#ifndef SECURE
#if defined MSDOS || defined osf1
	fputs ((catgets (catd, NL_SETN, 5, MSG_5)), stderr);
#else
	fputs ((catgets (catd, NL_SETN, 6, MSG_6)), stderr);
#endif
#endif
	putchar ('\n');
	fputs ((catgets (catd, NL_SETN, 7, MSG_7)), stderr);
#if defined MSDOS || defined osf1
	fputs ((catgets (catd, NL_SETN, 12, MSG_12)), stderr);
#else
	fprintf (stderr, (catgets (catd, NL_SETN, 13, MSG_13)), DEVICE_FILE);
#endif
}

void	analyze_option	(int argc, char **argv)

{
	int		c;
	
	mode = 'e';
	while ((c = getopt (argc, argv, "capemluhd:")) != -1 && c != '?')
	{
		switch (c)
		{
			case 'c':	mode = 'm';	break;
			case 'a':	mode = 'u';	break;
			case 'p':	mode = 'l';	break;

			case 'e':
			case 'm':
			case 'l':
			case 'u':
			mode = c;
			break;
			
			case 'h':
			usage ();
			exit (EXIT_FAILURE);
			
#ifndef SECURE
			case 'd':
#if defined MSDOS || defined osf1
			if (strchr (optarg, ',') == NULL)
				scsi_id = atoi (optarg);
			else
				sscanf (optarg, "%d,%d,%d", &ha_id, &scsi_id, &lun);
#else
			if (optarg [0] == _PATH_DELIM)
				strcpy (devicefile, optarg);
			else
				sprintf (devicefile, DEVICE_FILE_TMPL, optarg);
#endif
			break;
#endif
		}
	}
	
	if (c == '?' || argc - optind != 0)
	{
		usage ();
		exit (EXIT_FAILURE);
	}
}

void	open_device	(void)

{
	BYTE	InquiryData [255];
	#define	DEVTYPE	(InquiryData [0] & 0x1F)
	#define	RMB		(InquiryData [1] & 0x80)
	
#ifdef MSDOS
	if (InitASPI () == FAILURE)
	{
		fputs ((catgets (catd, NL_SETN, 15, MSG_15)), stderr);
		exit (EXIT_FAILURE);
	}
#else
#ifdef osf1
	if (OpenCAM () == FAILURE)
#else
	if ((fd = open (devicefile, OPENFLAG)) == FAILURE)
#endif
	{
		perror (NAME);
		exit (EXIT_FAILURE);
	}
#endif
	
	UnitAtnRetry = TRUE;
#if defined MSDOS || defined osf1
	if (scsi_id < 0)
	{
		for (scsi_id = 0; scsi_id <= 7; scsi_id++)
		{
			if (Inquiry (FD, InquiryData, sizeof InquiryData) == SUCCESS && 
				RMB)
				break;
		}
		if (scsi_id > 7)
		{
			fputs ((catgets (catd, NL_SETN, 16, MSG_16)), stderr);
			CLOSE (fd);
			exit (EXIT_FAILURE);
		}
		printf (catgets (catd, NL_SETN, 19, MSG_19), scsi_id);
		devtype = DEVTYPE;
		return;
	}
#endif
	
	if (Inquiry (FD, InquiryData, sizeof InquiryData) == FAILURE)
	{
		fputs ((catgets (catd, NL_SETN, 17, MSG_17)),stderr);
		CLOSE (fd);
		exit (EXIT_FAILURE);
	}
	if (RMB == 0)
	{
		fputs ((catgets (catd, NL_SETN, 18, MSG_18)), stderr);
		CLOSE (fd);
		exit (EXIT_FAILURE);
	}
	devtype = DEVTYPE;
}

void	check_medium	(void)

{
	if (mode != 'm' && devtype != SCSI_CDROM)
	{
#if defined MSDOS
		TestUnitReady (FD);
#endif
		if (TestUnitReady (FD) == FAILURE)
		{
			fputs ((catgets (catd, NL_SETN, 20, MSG_20)), stderr);
			CLOSE (fd);
			exit (EXIT_FAILURE);
		}
	}
}

int		perform	(void)

{
	int		stat;
	
	switch (mode)
	{
	case 'e':
		stat = StartStopUnit (FD, 2);
		break;
		
	case 'm':
		stat = StartStopUnit (FD, 3);
		break;
		
	case 'u':
		stat = PreventAllowMediumRemoval (FD, 0);
		break;
		
	case 'l':
		stat = PreventAllowMediumRemoval (FD, 1);
		break;
	}
	return stat;
}

void	main	(int argc, char **argv)

{
	int		stat;
	
#ifdef NLS
	setlocale (LC_ALL, "");
	catd = catopen (NAME, CATFLAG);
#endif
	
	banner ();
	analyze_option (argc, argv);
	open_device ();
	check_medium ();
	stat = perform ();
	
	CLOSE (fd);
	if (stat == FAILURE)
	{
		switch (mode)
		{
		case 'e':
			fputs ((catgets (catd, NL_SETN, 21, MSG_21)), stderr);
			break;
		case 'm':
			fputs ((catgets (catd, NL_SETN, 22, MSG_22)), stderr);
			break;
		case 'l':
			fputs ((catgets (catd, NL_SETN, 23, MSG_23)), stderr);
			break;
		case 'u':
			fputs ((catgets (catd, NL_SETN, 24, MSG_24)), stderr);
			break;
		}
		exit (EXIT_FAILURE);
	}
	
#ifdef NLS
	catclose (catd);
#endif
	exit (EXIT_SUCCESS);
}
