# makefile for MS-DOS

# Turbo C/C++
CC = tcc
CFLAGS = -mc -a- -DMSDOS -O -G- -Z+ -N- -f- -w+ -d
LD = tcc
LDFLAGS = -mc -a- -f-

# MS-C/Quick C
#CC = cl
#CC = qcl
#CFLAGS = -AC -Zp -DMSDOS -DMSC -DNO_SLEEP -DNO_STPCPY -Os -G2 -Gs -Ze -W1
#LD = cl
#LD = qcl
#LDFLAGS = -AC -Zp -Os -G2 -Gs -Ze

# LSI-C
#CC = lcc
#CFLAGS = -md -DMSDOS -DNO_SLEEP -lintlib
#LD = lcc
#LDFLAGS = -md -lintlib

BINDIR = B:\bin
MANDIR = B:\man
MANEXT = 1
RM = DEL
INSTALL = REPLACE /U
CP = COPY

# LSI-C rejects -U
SWITCHES = -DNLS
#SWITCHES = -DNLS -UDOS_BULK_FAT_WRITE -UDOS_USE_ALLOCMEM
NLSDRV = B:

MEI_RELEASE = 1.53
MOE_RELEASE = 1.53

# for Turbo C
MEI_DEFINES = $(SWITCHES) -DRELEASE="$(MEI_RELEASE)"
MOE_DEFINES = $(SWITCHES) -DRELEASE="$(MOE_RELEASE)"
# for Turbo C++ 4.0: dummy exception handlers
#SUPPLLIBS_C = noehc.lib
#SUPPLLIBS_S = noehs.lib

# for MS-C/Quick C
#MEI_DEFINES = $(SWITCHES) -DRELEASE=\"$(MEI_RELEASE)\"
#MOE_DEFINES = $(SWITCHES) -DRELEASE=\"$(MOE_RELEASE)\"

CMNOBJS = aspiscsi.obj getopt.obj perror.obj misclib.obj 
NLSOBJS = msgcat.obj setloc.obj
NLSHDRS = msgcat.h locale.h

all:	mei moe readme.txt msdos.txt unix.txt locale.dir locale.ali

mei:	mei.exe
moe:	moe.exe

mei.exe:	mei.obj $(CMNOBJS) $(NLSOBJS)
	$(LD) $(LDFLAGS) mei.obj $(CMNOBJS) $(NLSOBJS) $(SUPPLLIBS_C)

moe.exe:	moe.obj $(CMNOBJS) $(NLSOBJS)
	$(LD) $(LDFLAGS) moe.obj $(CMNOBJS) $(NLSOBJS) $(SUPPLLIBS_C)

mei.obj:	mei.c m_mei.h typedef.h aspiscsi.h getopt.h misclib.h $(NLSHDRS)
	$(CC) $(CFLAGS) $(MEI_DEFINES) -c mei.c

moe.obj:	moe.c m_moe.h typedef.h aspiscsi.h getopt.h $(NLSHDRS)
	$(CC) $(CFLAGS) $(MOE_DEFINES) -c moe.c

aspiscsi.obj:	aspiscsi.c aspiscsi.h typedef.h misclib.h
	$(CC) $(CFLAGS) -c aspiscsi.c

getopt.obj:	getopt.c getopt.h m_getopt.h typedef.h msgcat.h
	$(CC) $(CFLAGS) $(SWITCHES) -c getopt.c

msgcat.obj:	msgcat.c typedef.h $(NLSHDRS)
	$(CC) $(CFLAGS) -c msgcat.c

setloc.obj:	setloc.c locale.h typedef.h
	$(CC) $(CFLAGS) -c setloc.c

perror.obj:	perror.c msgcat.h typedef.h
	$(CC) $(CFLAGS) $(SWITCHES) -c perror.c

misclib.obj:	misclib.c misclib.h typedef.h
	$(CC) $(CFLAGS) $(SWITCHES) -c misclib.c

m_mei.h:	_en\mei.msg
	sed -f msg.sed _en\mei.msg > m_mei.h

m_moe.h:	_en\moe.msg
	sed -f msg.sed _en\moe.msg > m_moe.h

m_getopt.h:	_en\getopt.msg
	sed -f msg.sed _en\getopt.msg > m_getopt.h

install:	all
	$(INSTALL) *.exe $(BINDIR)

install.man:	mei.man moe.man
	lha u $(MANDIR)\mei.lzh mei.man
	lha u $(MANDIR)\moe.lzh moe.man

install.cat:	locale.dir locale.ali
	instcat $(NLSDRV)

locale.dir:	locdir.def genloc.exe
	genloc locale.dir locdir.def

locale.ali:	locali.def genloc.exe
	genloc locale.ali locali.def

genloc.exe:	genloc.c typedef.h msgcat.c
	$(CC) genloc.c $(SUPPLLIBS_S)

locale.exe:	locale.obj setloc.obj
	$(LD) $(LDFLAGS) locale.obj setloc.obj $(SUPPLLIBS_C)

locale.obj:	locale.c typedef.h locale.h
	$(CC) $(CFLAGS) -c locale.c

readme.txt:	readme.ntf
	ntf -t -o readme.txt readme.ntf

msdos.txt:	msdos.ntf
	ntf -t -o msdos.txt msdos.ntf

unix.txt:	unix.ntf
	ntf -t -o unix.txt unix.ntf

clean:
	$(RM) *.exe
	$(RM) *.obj
	$(RM) m_*.h

distrib:	distrib.doc distrib.src distrib.bin

distrib.doc:
	$(RM) mei_d.lzh
	$(RM) mei_d.tgz
	lha a -x mei_d.lzh *.txt *.man instcat.bat _en\*.* _ja\*.* _fr\*.*
	tar cagf mei_d.tar *.txt *.man instcat.bat _en     _ja     _fr
	gzip -S .tgz mei_d.tar

distrib.src:
	$(RM) mei_s.lzh
	$(RM) mei_s.tgz
	lha a -x mei_s.lzh *.mak *.c *.h *.def *.sed *.ntf
	tar cagf mei_s.tar *.mak *.c *.h *.def *.sed *.ntf
	gzip -S .tgz mei_s.tar

distrib.bin:
	$(RM) mei_e.lzh
	lha a -x mei_e.lzh mei.exe moe.exe locale.dir locale.ali

