/*
	OSF/1
	SCSI device driver interface module
	Copyright 1995,1996 (C) ITO Takayuki
*/

#ifndef _OSF1SCSI_H
#define	_OSF1SCSI_H

#include	"typedef.h"

#define	SCSI_DIRECT_ACCESS	0
#define	SCSI_CDROM	5
#define	SCSI_MO	7

extern unsigned	SCSIDriverStatus;
extern BYTE		SCSIStatus;
extern BYTE		SCSISenseKey;
extern BYTE		SCSISenseCode;
extern BYTE		SCSISenseCodeQ;
extern BOOL		UnitAtnRetry;
extern DWORD	blocksize;

#ifndef DEVICE_FILE
#define	DEVICE_FILE	"/dev/cam"
#endif

#ifdef __cplusplus
extern "C" {
#endif

int	OpenCAM		(void);
int	CloseCAM	(void);

int	Read10			(int hbaid, int scsiid, int lun,
					DWORD lba, WORD count, void *buf);
int	Write10			(int hbaid, int scsiid, int lun,
					DWORD lba, WORD count, void *buf);
int	WriteAndVerify	(int hbaid, int scsiid, int lun,
					DWORD lba, WORD count, void *buf);
int	WriteSame		(int hbaid, int scsiid, int lun,
					DWORD lba, WORD count, void *buf);

int	FormatUnit		(int hbaid, int scsiid, int lun);
int	TestUnitReady	(int hbaid, int scsiid, int lun);
int	ReadCapacity	(int hbaid, int scsiid, int lun, DWORD *buf);
int	RequestSense	(int hbaid, int scsiid, int lun, BYTE *buf, int buflen);
int	ModeSense		(int hbaid, int scsiid, int lun, BYTE *buf, int buflen);
int	Inquiry			(int hbaid, int scsiid, int lun, BYTE *buf, int buflen);
int	StartStopUnit				(int hbaid, int scsiid, int lun, int flag);
int	PreventAllowMediumRemoval	(int hbaid, int scsiid, int lun, int flag);

#ifdef __cplusplus
}
#endif

#endif

