/*
	NLS version of perror (3), strerror (3) for MS-DOS
	Copyright 1996 (C) ITO Takayuki
	
	Even if you do not use NLS, 
	perror() and strerror() here might be useful 
	when you use Turbo C/C++
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<errno.h>
#ifdef sunos4
	#include	"errno.h"
#endif
#include	"typedef.h"

#ifdef NLS
	#include	"msgcat.h"
	#define		OFLAG	NL_CAT_LOCALE
	static nl_catd	catd;
	#ifdef __TURBOC__
		#define	CATNAME	"perrortc"
		#define	sys_nerr2	sys_nerr
	#else
		#define	CATNAME	"perror"
		int sys_nerr2 = 253;
	#endif
#endif /* NLS */

#ifdef NLS
char	*strerror	(int errnum)

{
	static BOOL	initf = TRUE;
	char	*result;
	
	if (initf)
	{
		catd = catopen (CATNAME, OFLAG);
		initf = FALSE;
	}
	if (errnum < 0 || sys_nerr2 - 1 < errnum)
		result = NULL;
	else if ((result = catgets (catd, NL_SETD, 1 + errnum, NULL)) == NULL &&
		0 <= errnum && errnum < sys_nerr)
			result = sys_errlist [errnum];
	return result;
}

#elif defined (__TURBOC__) || defined sunos4
/* strerror() of Turbo C unreasonably appends \n */
/* SunOS 4.x does not have strerror(3) */
char	*strerror	(int errnum)

{
	if (errnum < 0 || sys_nerr - 1 < errnum)
		return NULL;
	return sys_errlist [errnum];
}
#endif

#if defined(NLS) || defined(__TURBOC__)
void	perror	(const char *s)

{
	if (s != NULL && *s != '\0')
	{
		fputs (s, stderr);
		putc (':', stderr);
		putc (' ', stderr);
	}
	if ((s = strerror (errno)) != NULL)
	{
		fputs (s, stderr);
		putc ('\n', stderr);
	}
}
#endif

